'****************************************************************************
'***             Beispielprogramm fr PC-Steckkarte DA 1326               ***
'****************************************************************************
'*** Programmname       : 1326BAS.BAS                                     ***
'*** Programmmiersprache: MS-DOS QBasic Version 1.1                       ***
'***                                                                      ***
'*** erstellt von        Datum                                            ***
'*** Ralf Mller         24.06.97                                         ***
'****************************************************************************
'*** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen             ***
'*** Tel.: 07462/7381                                                     ***
'*** Fax : 07462/7554                                                     ***
'****************************************************************************

'Porzedurdeklarationen
DECLARE SUB box (x1!, y1!, x2!, y!)  'zeichnet einen Rahmen
DECLARE SUB ausgabewert (kanal!)     'Einlesen eines Wertes und Ausgabe  an
                                     'die DA 1326
DECLARE SUB writeboard (wert, kanal) 'Wert auf DA 1326 ausgeben
'Hauptprogramm
COLOR 15, 1
CLS
CALL box(12, 2, 71, 5)
LOCATE 3, 13
COLOR 0, 7
PRINT " ERMA-Electronic GmbH, Max-Eyth-Str.8, 78194 Immendingen "
LOCATE 4, 13
PRINT "       Tel. 07462/7381               Fax 07462/7554      "
'Fenster fr digitale Eingnge
CALL box(11, 8, 26, 10)
CALL box(11, 12, 26, 14)
CALL box(11, 16, 26, 18)
CALL box(11, 20, 26, 22)
'Fenster fr Ausgnge 1-8
CALL box(30, 10, 52, 20)
'Abbruchbedingung schreiben
COLOR 7, 1
LOCATE 19, 31
PRINT "                     "
COLOR 3, 1
LOCATE 19, 36
PRINT "ESC = Ende"
'Text fr digitale Eingnge schreiben
COLOR 0, 7
FOR i = 0 TO 3
    LOCATE 9 + i * 4, 12
    PRINT USING " Eingang #: 1"; i + 1
NEXT i
'Text fr Ausgnge 1-8 schreiben
FOR i = 0 TO 7
    LOCATE 11 + i, 31
    PRINT USING " F# = Kanal #: ####"; i + 1; i + 1; 0
NEXT i
'Tastatureingabe abfragen
DO
    key$ = INKEY$
    SELECT CASE key$
        'Taste F1 bettigt
        CASE CHR$(0) + CHR$(59)
                ausgabewert (0)
        'Taste F2 bettigt
        CASE CHR$(0) + CHR$(60)
                ausgabewert (1)
        'Taste F3 bettigt
        CASE CHR$(0) + CHR$(61)
                ausgabewert (2)
        'Taste F4 bettigt
        CASE CHR$(0) + CHR$(62)
                ausgabewert (3)
        'Tatse F5 bettigt
        CASE CHR$(0) + CHR$(63)
                ausgabewert (4)
        'Taste F6 bettigt
        CASE CHR$(0) + CHR$(64)
                ausgabewert (5)
        'Taste F7 bettigt
        CASE CHR$(0) + CHR$(65)
                ausgabewert (6)
        'Taste F8 bettigt
        CASE CHR$(0) + CHR$(66)
                ausgabewert (7)
    END SELECT
    'Unterprogramm zum Einlesen der digitalen Eingnge
    GOSUB INEINGAENGE
'Abbruchbedingung = Taste ESC
LOOP UNTIL key$ = CHR$(27)
'Ausgangskanle auf Minimum des Bereiches setzen
FOR i = 0 TO 7
    CALL writeboard(&H0, i)
NEXT i
COLOR 7, 0
CLS
END
        
'Unterprogramm zum Einlesen der digitalen Eingnge
INEINGAENGE:
 wert = INP(&H100)
 COLOR 0, 7
 IF (wert AND &H10) > 0 THEN
     ausgabe = 1
 ELSE
     ausgabe = 0
 END IF
 LOCATE 9, 24
 PRINT USING "#"; ausgabe
 IF (wert AND &H20) > 0 THEN
     ausgabe = 1
 ELSE
     ausgabe = 0
 END IF
 LOCATE 13, 24
 PRINT USING "#"; ausgabe
 IF (wert AND &H40) > 0 THEN
     ausgabe = 1
 ELSE
     ausgabe = 0
 END IF
 LOCATE 17, 24
 PRINT USING "#"; ausgabe
 IF (wert AND &H80) > 0 THEN
     ausgabe = 1
 ELSE
     ausgabe = 0
 END IF
 LOCATE 21, 24
 PRINT USING "#"; ausgabe
RETURN

SUB ausgabewert (kanal)
 DO
     CALL box(56, 11 + kanal - 2, 71, 11 + kanal + 1)
     COLOR 0, 7
     LOCATE 11 + kanal - 1, 59
     PRINT "von 0-4095"
     fehler = 0
     keyinput$ = ""
     LOCATE 11 + kanal, 57
     PRINT "Wert: "
     FOR i = 1 TO 4
         DO
             taste$ = ""
             taste$ = INKEY$
             SELECT CASE taste$
                 CASE CHR$(48) TO CHR$(57)
                        fehler = 0
                 CASE CHR$(13)
                        fehler = 0
                        i = 4
                 CASE ELSE
                        fehler = 1
             END SELECT
         LOOP UNTIL fehler = 0
         keyinput$ = keyinput$ + taste$
         LOCATE 11 + kanal, 63
         PRINT keyinput$
     NEXT i
     wert = VAL(keyinput$)
     IF (wert < 0) OR (wert > 4095) THEN
         fehler = 1
     END IF
     IF fehler = 1 THEN
         LOCATE 11 + kanal, 57
         PRINT "falscher Wert"
         FOR i = 0 TO 5000
         NEXT i
         LOCATE 11 + kanal, 57
         PRINT "             "
     END IF
 LOOP UNTIL fehler = 0
 CALL writeboard(wert, kanal)
 LOCATE 11 + kanal, 46
 PRINT USING "####"; wert

 COLOR 0, 1
 LOCATE 11 + kanal - 2, 56
 PRINT "                  "
 LOCATE 11 + kanal - 1, 56
 PRINT "                  "
 LOCATE 11 + kanal, 56
 PRINT "                  "
 LOCATE 11 + kanal + 1, 56
 PRINT "                         "
 LOCATE 11 + kanal + 2, 56
 PRINT "                  "
END SUB

SUB box (x1, y1, x2, y2)
 COLOR 15, 7
 LOCATE y1, x1
 PRINT ("")
 LOCATE y1, x2
 PRINT ("")
 LOCATE y2, x1
 PRINT ("")
 LOCATE y2, x2
 PRINT ("")
 FOR i = x1 + 1 TO x2 - 1
  LOCATE y1, i
  PRINT ("")
  LOCATE y2, i
  PRINT ("")
 NEXT i
 FOR i = y1 + 1 TO y2 - 1
  LOCATE i, x1
  PRINT ("")
  LOCATE i, x2
  PRINT ("")
 NEXT i
 FOR i = y1 + 1 TO y2 - 1
  FOR n = x1 + 1 TO x2 - 1
   LOCATE i, n
   PRINT (" ")
  NEXT n
 NEXT i
 COLOR 0, 1
 FOR i = x1 + 2 TO x2 + 1
  LOCATE y2 + 1, i
  PRINT ("")
 NEXT i
 FOR i = y1 + 1 TO y2 + 1
  LOCATE i, x2 + 1
  PRINT ("")
 NEXT i
END SUB

SUB writeboard (wert, kanal)
 'Abfrage des Statusbit, ob vorherige DA-Wandlung noch aktiv ist
 DO
 LOOP UNTIL ((INP(&H100) AND &H8) <> 0)
 'neuer Messwert ausgeben
 OUT &H100, (wert AND 255)                      'obere 8 Bit
 OUT &H101, (INT(wert / 256) + (kanal * 16))    'untere 4 Bit
END SUB

